/**
 * Mupen64 - gcop1.c
 * Copyright (C) 2002 Hacktarux
 *
 * Mupen64 homepage: http://mupen64.emulation64.com
 * email address: hacktarux@yahoo.fr
 * 
 * If you want to contribute to the project please contact
 * me first (maybe someone is already making what you are
 * planning to do).
 *
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
**/

#include <stdio.h>
#include "../recomph.h"
#include "../recomp.h"
#include "assemble.h"
#include "../r4300.h"
#include "../ops.h"
#include "../../memory/memory.h"
#include "../macros.h"

void genlwc1()
{
   dst->local_addr = code_length;
   mov_eax_memoffs32((unsigned long *)(&reg[dst->f.lf.base]));
   add_eax_imm32((long)dst->f.lf.offset);
   mov_reg32_reg32(EBX, EAX);
   shr_reg32_imm8(EAX, 16);
   mov_reg32_preg32x4pimm32(EAX, EAX, (unsigned long)(readmem));
   cmp_eax_imm32((unsigned long)(read_rdram));
   je_rj(0x3B);
   
   mov_m32_reg32((unsigned long *)(&address), EBX);
   mov_reg32_m32(EDX, (unsigned long *)(&Status));
   and_reg32_imm32(EDX, 0x04000000);
   cmp_reg32_imm8(EDX, 0);
   je_rj(12);
   mov_m32_imm32((unsigned long *)(&rdword), (unsigned long)(&reg_cop1_fgr_64[dst->f.lf.ft]));
   jmp_imm_short(10);
   mov_m32_imm32((unsigned long *)(&rdword), (unsigned long)(&reg_cop1_fgr_32[dst->f.lf.ft]));
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst+1));
   
   call_reg32(EAX);
   jmp_imm_short(0x29);
   
   and_reg32_imm32(EBX, 0xFFFFFF);
   mov_reg32_preg32pimm32(EAX, EBX, (unsigned long)(rdram));
   mov_reg32_m32(EDX, (unsigned long *)(&Status));
   and_reg32_imm32(EDX, 0x04000000);
   cmp_reg32_imm8(EDX, 0);
   je_rj(7);
   mov_memoffs32_eax((unsigned long *)(&reg_cop1_fgr_64[dst->f.lf.ft]));
   jmp_imm_short(5);
   mov_memoffs32_eax((unsigned long *)(&reg_cop1_fgr_32[dst->f.lf.ft]));
   genupdate_system(0);
}

void genldc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(LDC1));
   call_reg32(EAX);
   genupdate_system(0);
}

void gensdc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(SDC1));
   call_reg32(EAX);
   genupdate_system(0);
}

void genswc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(SWC1));
   call_reg32(EAX);
   genupdate_system(0);
}

void genmfc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(MFC1));
   call_reg32(EAX);
   genupdate_system(0);
}

void gencfc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(CFC1));
   call_reg32(EAX);
   genupdate_system(0);
}

void genmtc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(MTC1));
   call_reg32(EAX);
   genupdate_system(0);
}

void gendmtc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(DMTC1));
   call_reg32(EAX);
   genupdate_system(0);
}

void genctc1()
{
   dst->local_addr = code_length;
   mov_m32_imm32((void *)(&PC), (unsigned long)(dst));
   mov_reg32_imm32(EAX, (unsigned long)(CTC1));
   call_reg32(EAX);
   genupdate_system(0);
}
